#include "winbuf.hh"
#include <cstdio>

void winbuf::resize(unsigned nxs, unsigned nys)
{
	xs = nxs;
	ys = nys;
	buf.resize(nys);
	for(unsigned a=0; a<nys; ++a)
		buf[a].resize(nxs, defblock);
}
const winbuf winbuf::piece(unsigned x1,unsigned y1, unsigned x2,unsigned y2) const
{
	/*
	printf("Would like to get piece(%u,%u,%u,%u)", x1,y1, x2,y2);
	printf(" from buffer(%u,%u) (at %p)\n", xs,ys, this);
	fflush(stdout);
	*/
	
	unsigned width = x2-x1+1;
	unsigned height = y2-y1+1;
	buffer tmp(height);
	for(unsigned a=0; a<height; ++a)
	{
		unsigned yp = a+y1, xp = x1;
		tmp[a].resize(width);
		vector<winchar> &destrow = tmp[a];
		const vector<winchar> &srcrow = buf[yp];
		for(unsigned b=0; b<width; ++b)
			destrow[b] = srcrow[xp++];
	}
	return winbuf(tmp, width, height);
}
void winbuf::drawfrom(const winbuf &w, unsigned x, unsigned y)
{
	if(x >= xs || y >= ys)return;
	for(unsigned a=0; a<w.height(); ++a)
	{
		for(unsigned b=0; b<w.width(); ++b)
		{
			if(x+b >= xs)break;
			buf[y][x+b].mixwith(w.buf[a][b]);
		}
		if(++y >= ys)break;
	}
}
