#ifndef bqt_winbuf_hh
#define bqt_winbuf_hh

#include <vector>

#include "winchar.hh"

class winbuf
{
	unsigned xs, ys;
public:
	typedef vector< vector<winchar> > buffer;
	winchar defblock;
	buffer buf;
public:
	winbuf() : xs(0), ys(0) { }
	winbuf(unsigned x, unsigned y) : xs(x), ys(y) { resize(xs, ys); }
	winbuf(const buffer &b, unsigned x, unsigned y) : xs(x), ys(y), buf(b) { }
	void resize(unsigned nxs, unsigned nys);
	const winbuf piece(unsigned x1,unsigned y1, unsigned x2,unsigned y2) const;
	unsigned width() const { return xs; }
	unsigned height() const { return ys; }
	void drawfrom(const winbuf &w, unsigned x, unsigned y);
	inline void drawfrom(const winbuf &w) { drawfrom(w, 0, 0); }
};

#endif
